<template>
    <div>
        <el-tooltip class="box-item" effect="dark" content="_)" placement="bottom-end">
            <el-image @click="()=>{addEmoi('_)')}" :src="emoi0" style="width:15px; height: 15px" fit="fill" />
        </el-tooltip>
        <el-tooltip class="box-item" effect="dark" content="3)" placement="bottom-end">
        <el-image @click="()=>{addEmoi('3)')}" :src="emoi1" style="width:15px; height: 15px" fit="fill" />
    </el-tooltip>
        <el-tooltip class="box-item" effect="dark" content="3D" placement="bottom-end">
            <el-image @click="()=>{addEmoi('3D')}" :src="emoi2" style="width:15px; height: 15px" fit="fill" />
        </el-tooltip>
        <el-tooltip class="box-item" effect="dark" content="8D" placement="bottom-end">
            <el-image @click="()=>{addEmoi('8D')}" :src="emoi3" style="width:15px; height: 15px" fit="fill" />
        </el-tooltip>
        <el-tooltip class="box-item" effect="dark" content="8E" placement="bottom-end">
            <el-image @click="()=>{addEmoi('8E')}" :src="emoi4" style="width:15px; height: 15px" fit="fill" />
        </el-tooltip>
        <div @keyup="handleKeyUp" ref="input" id="message-input" contenteditable="true">
        </div>
    </div>
</template>
<script setup lang="ts">

import { ref, Ref, watch } from 'vue';
// @ts-ignore
import emoi0 from '@/assets/emois/_).png';
// @ts-ignore
import emoi1 from '@/assets/emois/3).png';
// @ts-ignore
import emoi2 from '@/assets/emois/3D.png';
// @ts-ignore
import emoi3 from '@/assets/emois/8D.png';
// @ts-ignore
import emoi4 from '@/assets/emois/8E.png';

interface Props {
    message: String
}

const props = defineProps<Props>();
const emit = defineEmits(['message', 'enter']);
const input = ref(null);

const emois: Ref<String[]> = ref(['_\)', '3\)', '3D', '8D', '8E']);

watch(() => props.message, (newValue, oldValue) => {
    if (newValue === '') {
        input.value.innerHTML = '';
    }
})

function handleKeyUp(e) {
    if (e.key === 'Enter' && input.value.innerHTML !== '') {
        input.value.innerHTML = '';
        emit('enter');
    }

    emois.value.forEach(emoi => {

        if (input.value.innerHTML.endsWith(emoi)) {
            let regex = new RegExp(emoi.replace(')', '\\)') + '$');
            input.value.innerHTML = input.value.innerHTML.replace(regex, '');
            let img = document.createElement('img');
            img.setAttribute('width', '15px');
            img.setAttribute('height', 'auto');
            img.setAttribute('x-data', emoi0[0]);
            switch (emoi) {
                case '_)': img.src = emoi0; break;
                case '3)': img.src = emoi1; break;
                case '3D': img.src = emoi2; break;
                case '8D': img.src = emoi3; break;
                case '8E': img.src = emoi4; break;
            }
            input.value.appendChild(img);
            setEndOfContenteditable(input.value);
        }

        if (e.key === 'Backspace' && input.value.innerHTML.match(/<img x-data=".*"[^>]*>/)) {
            input.value.innerHTML = input.value.innerHTML.replace(/<img x-data="(.*)"[^>]*>/, '$1');
            e.preventDefault();
        }
    })
    emit('message', e.target.innerHTML)
}

function setEndOfContenteditable(elem) {
    let sel = window.getSelection();
    sel.selectAllChildren(elem);
    sel.collapseToEnd();
}

function addEmoi(emoi: string) {
    input.value.innerHTML+=emoi;
    handleKeyUp({target: input.value});
}

</script>
<style scoped lang="scss">
#message-input {
    transition: all .5s ease-out;
    overflow: auto;
    margin: 10px;
    padding: 10px;
    border-radius: 5px;
    box-shadow: inset -1px -1px 1px 0px rgba(16, 16, 16, 0.68);
    width: 100%;
    height: 100px;

    &:focus {
        transition: all .5s ease-in;
        outline: 0px solid transparent;
        box-shadow: inset -1px -1px 1px 0px rgba(16, 16, 16, 1);
    }
}
</style>